<?php

namespace STM\Person;

use \Exception;
use STM\StmFactory;

/**
 * Test class for Person.
 * Generated by PHPUnit on 2012-02-22 at 10:04:38.
 * @group person
 */
class PersonTest extends \PHPUnit_Framework_TestCase {

    /** @var array(Person) */
    private $allPersons;

    protected function setUp() {
        $this->allPersons = StmFactory::find()->Person->findAll();
    }

    public function testfindById() {
        foreach ($this->allPersons as $person) {            
            parent::assertInstanceOf('\STM\Person\Person', StmFactory::find()->Person->findById($person->getId()));
        }
        // argument must be numeric
        parent::assertFalse(StmFactory::find()->Person->findById('Zdenda'));
        parent::assertFalse(StmFactory::find()->Person->findById(null));
        parent::assertFalse(StmFactory::find()->Person->findById(new Exception()));
    }


    public function testFind_all() {
        parent::assertTrue(is_array($this->allPersons));
        foreach ($this->allPersons as $person) {            
            parent::assertInstanceOf('\STM\Person\Person', $person);
        }
    }


    public function testCreate() {
        parent::markTestSkipped('test in PersonValidatorTest');
    }

    public function testDelete() {
        parent::markTestSkipped('in testCan_be_deleted, otherwise only DB fail');
    }

    public function testCan_be_deleted() {
        foreach ($this->allPersons as $person) {
            $teams = StmFactory::find()->TeamMember->findByPerson($person);
            $clubs = StmFactory::find()->ClubMember->findByPerson($person);
            $referees = StmFactory::find()->MatchReferee->findByPerson($person);
            $canBeDeleted = empty($teams) && empty($clubs) && empty($referees);
            parent::assertTrue($person->canBeDeleted() == $canBeDeleted);
        }
    }

    public function testUpdate() {
        parent::markTestSkipped('test in PersonValidatorTest');
    }

    public function testGet_id() {
        $this->assert_get_to_function('is_int', 'getId');
    }

    public function testGet_id_country() {
        $this->assert_get_to_function('is_scalar', 'getIdCountry');
    }

    public function testTo_array() {
        $this->assert_get_to_function('is_array', 'toArray');
    }

    public function test__toString() {
        $this->assert_get_to_function('is_string', '__toString');
    }

    private function assert_get_to_function($function, $method_name) {
        foreach ($this->allPersons as $person) {
            parent::assertTrue($function($person->$method_name()));
        }
    }
}

?>
